
int Find_nearest_inf_ship(ref chr)
{
	ref rGroup;
	ref pchar = GetMainCharacter();
	string groupname;
	float visibility_range = 3000.0; // maximal visibility range

	int i;
	ref achr;
	int achridx;
	int place = -1;
	float enemydist;
	enemydist = 0.0;
	float memoire=0.0;

	if(CheckAttribute(chr,"runaway")){DeleteAttribute(chr,"runaway");}

	//logit("FOG Weathers.Fog.SeaDensity : " + Weathers.Fog.SeaDensity + " !");

//	visibility_range = (2.6/stf(Weathers.Fog.SeaDensity));
	visibility_range = visibility_range - (stf(Weathers.Fog.SeaDensity) * 130 * visibility_range);
	
	// more a character have leadership and sailing skills and more he can see far

	// TODO: Aconcagua: suppose we should use the effective value -> use GetCharacterSkill
	// perhaps even GetSummonSkillFromName???
	// compare BattleInterface.c
	//visibility_range = visibility_range + (stf(chr.skill.Leadership) * stf(chr.skill.sailing)*5);
	visibility_range = visibility_range + (GetCharacterSkill(chr, SKILL_LEADERSHIP) * GetCharacterSkill(chr, SKILL_SAILING) * 5);

	if(Whr_IsNight())
	{
		visibility_range = visibility_range / 2;
		if(HasCharacterShipAttribute(chr, "night_stealth"))		visibility_range = visibility_range / 2;	// PB: Black Pearl stealth at night
	}
	//logit("Visibility range : " + visibility_range + " !");

	for (i=0; i<MAX_SHIP_GROUPS; i++)
	{
		rGroup = Group_GetGroupByIndex(i);
		if(CheckAttribute(rGroup,"AlreadyLoaded"))
		{
			//Logit(" " + rgroup.id + "   ");

			if (!CheckAttribute(rGroup, "id")) { continue; }
			if (!CheckAttribute(rGroup, "location")) { continue; }
			if (rGroup.location != Pchar.location) { continue; }
			achr = Group_GetGroupCommanderR(rGroup);

			if(CheckAttribute(achr,"surrendered") || CharacterIsDead(achr)){continue;} //Group_UpdateGroup(achr);continue;}
			if(!Checkattribute(achr,"index")){continue;}
			if(GetNationRelation(sti(achr.nation), sti(chr.nation)) == RELATION_ENEMY)
			{
				//achr = Group_GetGroupCommander(rGroup.id);
				enemydist = Ship_GetDistance2D(achr, chr);
				if(enemydist <= visibility_range && Ship_power_inf(chr,achr))
				{
					//Logit(" " + chr.Ship.Pos.x + "   ");
					//Logit(" Enemy distance : " + enemydist + "   ");
					if(enemydist < memoire || place == -1)
					{
						if(place == -1 || GetCharacterSkill(chr, Skill_LEADERSHIP)>4) // lower captains are Stubborn
						{
							place = achr.index;
							memoire = enemydist;
						}
					}
				}
			}
		}
		else
		{
			if(CheckAttribute(rGroup, "id"))
			{
				achr = Group_GetGroupCommanderR(rGroup);
				if(CheckAttribute(achr, "id") && HasSubStr(achr.id, "fenc_"))
				{
					achr = Group_GetGroupCommanderR(rGroup);
					if(CheckAttribute(achr,"surrendered") || CharacterIsDead(achr)){continue;}
					if(!Checkattribute(achr,"index")){continue;}
					if(GetNationRelation(sti(achr.nation), sti(chr.nation)) == RELATION_ENEMY)
					{
						enemydist = Ship_GetDistance2D(achr, chr);
						if(enemydist <= visibility_range && Ship_power_inf(chr,achr))
						{
							if(enemydist < memoire || place == -1)
							{
								if(place == -1 || GetCharacterSkill(chr, SKILL_LEADERSHIP)>4) //lower captains are Stubborn
								{
									place = achr.index;
									memoire = enemydist;
								}
							}
						}
					}
				}
			}
		}
	}

	if(GetFlagRMRelation(sti(chr.nation)) > REL_WAR && GetRelation(sti(pchar.index), sti(chr.index)) != RELATION_ENEMY && sti(Pchar.nation)!=PERSONAL_NATION && GetRMRelationType(GetActualRMRelation(sti(chr.nation))) == RELATION_ENEMY)
	{
		CheckForMainCharacterfalseflag(chr,visibility_range);
	}

	if(GetNationRelation(sti(pchar.nation), sti(chr.nation)) == RELATION_ENEMY || GetRelation(sti(pchar.index), sti(chr.index)) == RELATION_ENEMY)
	{
		enemydist = Ship_GetDistance2D(pchar, chr);
		if(enemydist <= visibility_range && Ship_power_inf(chr,pchar))
		{
			//if(enemydist < Ship_GetDistance2D(GetCharacter(place), chr) || place == -1){place = Pchar.index;}
			if(enemydist < memoire || place == -1)
			{
				if(place == -1 || GetCharacterSkill(chr, SKILL_LEADERSHIP)>4)
				{
					place = Pchar.index;
					memoire = enemydist;
				}
			}
		}
	}
	
	return place;
}

//the checking of the fort distance seems to not work properly!!!!!!!!!!
// it works in some situations but not in some others
bool Check_close_enemy_fort(ref chr, float fortdistance)
{
	ref Pchar = GetMainCharacter();
	if(Pchar.location==""){return false;}

	bool result = false;
	int i;
	ref achr;
	float enemydist = 0.0;
	string fort_locator;

	for (i=1; i<4; i++)
	{
		fort_locator = "Reload_fort" + i;
//		ReloadProgressUpdate();
		int iFortCharacter = Fort_FindCharacter(Pchar.location, "reload", fort_locator);
		if (iFortCharacter >= 0)
		{
			achr = GetCharacter(iFortCharacter);
			if(CheckAttribute(achr,"surrendered") || CharacterIsDead(achr)){continue;}
			if(GetNationRelation(sti(achr.nation), sti(chr.nation)) == RELATION_ENEMY)
			{
				//Logit("fort : " + achr.id + "  ");
				enemydist = Ship_GetDistance2D(achr, chr);
				if(enemydist <= fortdistance)
				{
					//Logit("Distance to fort : " + enemydist + "  ");
					//chr.runaway = "1";
					result = true;
					//return true;
				}
			}
		}
	}
	return result;
}

// To check if chr1 ship is stonger than chr2 ship
bool Ship_power_inf(ref chr1, ref chr2)
{
	ref rgroup = Group_GetGroupByID(GetGroupIDFromCharacter(chr1));
	ref rgroup2 = Group_GetGroupByID(GetGroupIDFromCharacter(chr2));
	bool result = false;

	if(GetCannonCurQuantity(chr1)<=0) {chr1.runaway = "1";result=true;}

	/// PIRATES REACTIONS
	if(CheckAttribute(chr1,"fantomtype") && chr1.fantomtype == "pirate")
	{
		// THEY DON'T LIKE WAR SHIPS BUT ATTACK THEM IF THEY HAVE SUPERIOR POWER
		if(CheckAttribute(chr2,"fantomtype") && chr2.fantomtype == "war" || chr2.index == GetMainCharacterIndex())
		{
			//logit("Power rgroup : " + Group_GetPowerHP_R(rGroup));
			//logit("Power rgroup2 : " + Group_GetPowerHP_R(rGroup2));
			if(Group_GetPowerHP_R(rGroup) >= Group_GetPowerHP_R(rGroup2))
			{
				result = true;
				//logit("i'm stronger");
			}
			else
			{
				//logit("number ships rgroup : " + Group_GetCharactersNumR(rGroup));
				//logit("number ships rgroup2 : " + Group_GetCharactersNumR(rGroup2));
				If(Group_GetCharactersNumR(rGroup) >= Group_GetCharactersNumR(rGroup2) && GetCharacterShipClass(chr1) <= GetCharacterShipClass(chr2))
				{
					result = true;
					//logit("j'attaque");
				}
				else
				{
					// They run away
					chr1.runaway = "1";
					result = true;
					if(Ship_GetDistance2D(chr1, chr2) < 200 && GetCannonCurQuantity(chr1)>2 && GetCargoGoods(chr1,GOOD_GUNPOWDER)>0)
					{
						if(GetCargoGoods(chr1,GOOD_BALLS)>0 || GetCargoGoods(chr1,GOOD_KNIPPELS)>0) // stop running and defend if a bigger enemy is too close
						{
							DeleteAttribute(chr1,"runaway");
						}
					}
				}
			}
		}
		else
		{
			// TRADE SHIPS : They attack
			If(GetCharacterShipClass(chr2) == 1)
			{
				// Pirates don't like big escorts
				chr1.runaway = "1";
				result = true;
			}
			else
			{
				result = true;
			}
		}
	}

	// WAR SHIPS REACTIONS
	if(CheckAttribute(chr1,"fantomtype") && chr1.fantomtype == "war")
	{
		if(CheckAttribute(chr2,"fantomtype") && chr2.fantomtype == "war" || chr2.index == GetMainCharacterIndex())
		{
			if(Group_GetPowerHP_R(rGroup) >= Group_GetPowerHP_R(rGroup2))
			{
				result = true;
			}
			else
			{
				If(Group_GetCharactersNumR(rGroup) >= Group_GetCharactersNumR(rGroup2) && GetCharacterShipClass(chr1) <= GetCharacterShipClass(chr2))
				{
					result = true;
				}
				else
				{
					// They run away
					chr1.runaway = "1";
					result = true;
					if(Ship_GetDistance2D(chr1, chr2) < 200 && GetCannonCurQuantity(chr1)>2 && GetCargoGoods(chr1,GOOD_GUNPOWDER)>0)
					{
						if(GetCargoGoods(chr1,GOOD_BALLS)>0 || GetCargoGoods(chr1,GOOD_KNIPPELS)>0) // stop running and defend if a bigger enemy is too close
						{
							DeleteAttribute(chr1,"runaway");
						}
					}
				}
			}
		}
		else
		{
			// TRADE SHIPS OR PIRATES : They attack
			result = true;
		}
	}

	//if(Check_close_enemy_fort(chr1, 2300)) {chr1.runaway = "1";}

	//if(GetCannonCurQuantity(chr1) >= GetCannonCurQuantity(chr2) && GetCurrentShipHP(chr1) >= GetCurrentShipHP(chr2)) result = true;

	if(CheckAttribute(Chr1,"Fantomtype") && chr1.fantomtype == "trade") result = true; // trade ship have other reactions

	return result;
}

// Merchants basically run away but can attack if enemy is to close and if they have superiority
bool Check_courageous_merchant(ref chr1, ref chr2)
{
	ref rgroup = Group_GetGroupByID(GetGroupIDFromCharacter(chr1));
	ref rgroup2 = Group_GetGroupByID(GetGroupIDFromCharacter(chr2));
	float range = 600.0;
	//if(Whr_IsNight()){range = 800;}
	bool result = false;

	if(GetCannonCurQuantity(chr1)<=0) return false;

	if(Ship_GetDistance2D(chr1, chr2) < range  && GetCargoGoods(chr1,GOOD_GUNPOWDER)>0)
	{
		if(GetCargoGoods(chr1,GOOD_BALLS)>0 || GetCargoGoods(chr1,GOOD_KNIPPELS)>0)
		{
			if(Group_GetPowerHP_R(rGroup) >= Group_GetPowerHP_R(rGroup2)) return true;

			If(Group_GetCharactersNumR(rGroup) >= 2 * Group_GetCharactersNumR(rGroup2)) return true;

			if(GetCharacterShipClass(chr1) <=  GetCharacterShipClass(chr2) - 2) return true;

			if(GetCannonCurQuantity(chr1) > GetCannonCurQuantity(chr2) && GetCurrentShipHP(chr1) > GetCurrentShipHP(chr2)) return true;

			if(Ship_GetDistance2D(chr1, chr2) < 200 && GetCannonCurQuantity(chr1)>2)return true;
		}
	}

	return result;
}

void CheckForMainCharacterfalseflag(ref chr, float range)
{
	Ref Pchar = GetmainCharacter();
	ref rgroup = Group_GetGroupByID(GetGroupIDFromCharacter(chr));
	float distance;
	int i = 0;
	bool Recognized = false; // To avoid being recognized if we hoist our own nation flag

	if (ENABLE_FLAGS == 1)
	{
		distance = Ship_GetDistance2D(Pchar, chr);
		if(distance <= range)
		{
			int MyFlag = GetCurrentFlag();
			float chance = 1 - (distance / range);
			chance = 0.5 + chance; // 0.5 will be decreased if you are too easily recognized
			//logit(" "+chance+" ");

			if (iForceDetectionFalseFlag == 0) {
				if ((frnd() >= (GetChanceDetectFalseFlag() * chance)) || (MyFlag == PERSONAL_NATION)) {
					MyFlag = GetCurrentFlag();
				} else {
					MyFlag = PERSONAL_NATION;
					Recognized = true;
				}
			}
			if (iForceDetectionFalseFlag == 1)
			{
					MyFlag = PERSONAL_NATION;
					Recognized = true;
			}
			if(Recognized==true && GetRMRelationType(GetActualRMRelation(sti(chr.nation))) == RELATION_ENEMY && !Checkattribute(chr,"recognized"))
			{
				chr.recognized = 1;
				chr.EnemyShipName = Pchar.Ship.Name;
				chr.EnemyShipType = Pchar.Ship.Type;
				if(iRealismMode == 0) Log_SetStringToLog(TranslateString("", "We are recognized, captain!")); // PB: Not very realistic to get a log message on this
				SetCharacterRelationBoth(sti(chr.index), sti(Pchar.index), RELATION_ENEMY);
				// Each ship of group must have recognized you just in case where leader would surrender or be destroyed
				bool fini = false;
				while (!fini)
				{
					int iCharacterIndex = Group_GetCharacterIndexR(rGroup, i); i++;
					if(iCharacterIndex >= 0)
					{
						Characters[iCharacterIndex].recognized = 1;
						Characters[iCharacterIndex].EnemyShipName = Pchar.Ship.Name;
						Characters[iCharacterIndex].EnemyShipType = Pchar.Ship.Type;
					}
					else
					{
						fini = true;
					}
				}
				UpdateRelations();
			}
			if(distance < 1000){Pchar.obsenemy ="1";}
		}
	}
}

Void Improve_SeaAi(String groupe)
{
	ref crgchar = Group_GetGroupCommander(groupe);
	if(CheckAttribute(crgchar,"surrendered") || CharacterIsDead(crgchar)){return;}
	float x, z;
	int enemydist = 0;
	int nextenemy = 0;
	string sLocationGroup, sLocationLocator;
	ref rIsland;
	string sTst;
	ref rGroup = Group_GetGroupByID(groupe);
	ref pchar = GetMainCharacter();
	//logit("Leadership : " + crgchar.skill.leadership + " ");
	if(CheckAttribute(crgchar,"fantomtype") && crgchar.fantomtype=="trade")
	{
		nextenemy = Find_nearest_inf_ship(crgchar);
		if(nextenemy!= -1) // && Characters[nextenemy].ship.type != SHIP_FORT_NAME ) 
		{
			if(Check_courageous_merchant(crgchar, &Characters[nextenemy]) || GetCharacterShipClass(crgchar) < 3)
			{
				Group_UnlockTask(groupe);
				Group_SetTaskAttack(groupe, GetGroupIDFromCharacter(GetCharacter(nextenemy)));
				Group_LockTask(groupe);
				//logit("i'm " + crgchar.id + " a brave merchant and i'm defending !");
			}
			else
			{
				Group_UnlockTask(groupe);
				Group_SetTaskRunaway(groupe);
				Group_LockTask(groupe);
				//logit("I'm " + crgchar.id + " a merchant and i have a too closer enemy so i'm running away !");
				if(Group_GetTask(groupe)==AITASK_MOVE)
				{
					rGroup.memo.x = rGroup.Task.Target.Pos.x;
					rGroup.memo.z = rGroup.Task.Target.Pos.z;
				}
				else
				{
					if(Group_GetTask(groupe)!=AITASK_ATTACK)
					{
						rGroup.memo.x = crgchar.ship.Pos.x;
						rGroup.memo.z = crgchar.ship.Pos.z;
					}
				}
			}
		}
		else
		{
			if(Group_GetTask(groupe)==AITASK_RUNAWAY || Group_GetTask(groupe)==AITASK_ATTACK)
			{
				if(CheckAttribute(rGroup,"memo"))
				{
					x = stf(rGroup.memo.x);
					z = stf(rGroup.memo.z);
					Group_UnlockTask(groupe);
					Group_SetTaskMove(groupe, x, z);
					Group_LockTask(groupe);
					DeleteAttribute(rGroup,"memo");
					//logit("I'm " + crgchar.id + " a merchant ! there's no more danger so i can return to my initial route !");
				}
				//else{Logit("I'm " + crgchar.id + " an anchoring merchant !");}
			}
			else
			{
				if(Group_GetTask(groupe)==AITASK_MOVE)
				{
					Group_UnlockTask(groupe);
					Group_SetTaskMove(groupe, stf(rGroup.Task.Target.Pos.x), stf(rGroup.Task.Target.Pos.z));
					Group_LockTask(groupe);
					//Logit("I'm " + crgchar.id + " a merchant sailing to a destination !");
				}
				//else{Logit("I'm " + crgchar.id + " an anchoring merchant !");}
			}
		}
	}

	if(CheckAttribute(crgchar,"fantomtype"))
	{
		if(crgchar.fantomtype=="pirate" || crgchar.fantomtype=="war")
		{

			//nextenemy = FindClosestShipofRel(crgchar.index, &enemydist, RELATION_ENEMY);
			nextenemy = Find_nearest_inf_ship(crgchar);
			if(CheckAttribute(crgchar,"runaway")) 
			{
				Group_UnlockTask(groupe);
				Group_SetTaskRunaway(groupe);
				Group_LockTask(groupe);
				//Logit("I'm " + crgchar.id + " a " + crgchar.fantomtype + " and i'm running away !");
			}
			else
			{
				if(nextenemy!= -1) 
				{
					Group_UnlockTask(groupe);
					Group_SetTaskAttack(groupe, GetGroupIDFromCharacter(GetCharacter(nextenemy)));
					Group_LockTask(groupe);
					//logit("I'm " + crgchar.id + " a " + crgchar.fantomtype + " and i'm attacking " + Characters[nextenemy].id + " !");
				}
				else
				{
					// find new Quest_ship locator to patrol
					if(Pchar.location!="")
					{
						sLocationGroup = "Quest_ships";
						sLocationLocator = GetRandomQuestShipLocator(Pchar.location); // PB

						rIsland = GetIslandByID(Pchar.location);
						sTst = sLocationGroup + "." + sLocationLocator + ".x";

						if (CheckAttribute(rIsland, sTst) || CheckAttribute(rGroup,"memo"))
						{
							if(CheckAttribute(rGroup,"memo"))
							{
								if(GetDistance2D(stf(crgchar.ship.Pos.x), stf(crgchar.ship.Pos.z), stf(rGroup.memo.x), stf(rGroup.memo.z)) <= 500)
								{
									x = stf(rIsland.(sLocationGroup).(sLocationLocator).x);
									z = stf(rIsland.(sLocationGroup).(sLocationLocator).z);
									rGroup.memo.x = x;
									rGroup.memo.z = z;
									//logit("I'm " + crgchar.id + " a  " + crgchar.fantomtype + " and i'm patroling to " + sLocationLocator + " !");
								}
								else
								{
									x = stf(rGroup.memo.x);
									z = stf(rGroup.memo.z);							
									//logit("I'm " + crgchar.id + " a " + crgchar.fantomtype + " and i'm to " + GetDistance2D(stf(crgchar.ship.Pos.x), stf(crgchar.ship.Pos.z), stf(rGroup.memo.x), stf(rGroup.memo.z)) + " yards of my next patrol point !");
								}
							}
							else
							{
								x = stf(rIsland.(sLocationGroup).(sLocationLocator).x);
								z = stf(rIsland.(sLocationGroup).(sLocationLocator).z);
								rGroup.memo.x = x;
								rGroup.memo.z = z;
								//logit("I'm " + crgchar.id + " a " + crgchar.fantomtype + " and i'm patroling to " + sLocationLocator + " !");
							}
						}
						else
						{
							if(rand(1)==0){x = 10000.0 * rand(10);}else{x = -10000.0 * rand(10);}
							if(rand(1)==0){z = 10000.0 * rand(10);}else{z = -10000.0 * rand(10);}
							if(CheckAttribute(rGroup,"memo")){DeleteAttribute(rGroup,"memo");}
						}
					}
					else
					{
						if(rand(1)==0){x = 10000.0 * rand(10);}else{x = -10000.0 * rand(10);}
						if(rand(1)==0){z = 10000.0 * rand(10);}else{z = -10000.0 * rand(10);}
						if(CheckAttribute(rGroup,"memo")){DeleteAttribute(rGroup,"memo");}
					}
					Group_UnlockTask(groupe);
					Group_SetTaskMove(groupe, x, z);
					Group_LockTask(groupe);
					//logit("I'm " + crgchar.id + " a " + crgchar.fantomtype + " without target or i've lost my target !");
				}
			}
		}
	}
}

void Refreshseacolor_in()
{
	if (bSeaActive && !bAbordageStarted) {
		SetEventHandler("frame", "BI_Refreshseacolor_in", 1);
		return;
	}
}
void Refreshseacolor_out()
{
	if (bSeaActive && !bAbordageStarted) {
		SetEventHandler("frame", "BI_Refreshseacolor_out", 1);
		return;
	}
}